include mt.e

procedure print_random_numbers(integer iterations, integer max_number)
 for i = 1 to iterations do
  printf(1,"%5d ", {mt_rand(max_number)})
  if (remainder(i, 10) = 0) then
   puts(1, "\n")
  end if
  end for
 puts(1,"\n")
end procedure


--
-- This block runs the standard MT test .. compare it with the data at:
--  http://www.math.keio.ac.jp/~nisimura/random/int/mt19937int.out
--
puts(1,"The standard 'Mersenne Twister' test.\n")
mt_set_rand(4357)
for i = 1 to 1000 do
 printf(1,"%10d ", {mt_rand_a(#FFFFFFFF)})
 if (remainder(i, 5) = 0) then
  puts(1, "\n")
 end if
end for
puts(1,"\n")


--
-- re-seed the twister and run 'mt_rand' 50 times drawing numbers from 1 to 100
--
puts(1,"Generating 50 numbers between 1 and 100\n")
mt_set_rand(rand(2000))
print_random_numbers(50, 100)


--
-- save/restore the twister example
--
sequence my_twister

puts(1,"Seeding the twister with a random number\n")
mt_set_rand(rand(1234567))
print_random_numbers(20, 500)

puts(1,"Saving the twister state .. generating 20 numbers\n")
my_twister = mt_get()
print_random_numbers(20, 500)

puts(1,"Restoring the twister state .. generating 20 numbers\n")
mt_set(my_twister[1], my_twister[2])
print_random_numbers(20, 500)
